
#include <stdlib.mqh>

int start() {
   while (IsExpertEnabled()) {
      _visual_sltp(Symbol());
      ObjectsRedraw();
      Sleep(314);
   }
   return (0);
}

int deinit() {
   string l_name_0;
   for (int li_8 = ObjectsTotal() - 1; li_8 >= 0; li_8--) {
      l_name_0 = ObjectName(li_8);
      if (StringSubstr(l_name_0, 0, 1) == "_") ObjectDelete(l_name_0);
   }
   ObjectsRedraw();
   //Comment(WindowExpertName() + " finished.");
   return (0);
}

void _visual_sltp(string a_symbol_0, int a_magic_8 = 0) {
   string l_name_12;
   int li_20;
   int li_24;
   for (int l_pos_28 = 0; l_pos_28 <= OrdersTotal(); l_pos_28++) {
      if (OrderSelect(l_pos_28, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderMagicNumber() == a_magic_8 || a_magic_8 == 0) {
            if (OrderSymbol() == a_symbol_0) {
               if (OrderStopLoss() > 0.0) {
                  l_name_12 = "_SL" + OrderTicket();
                  li_20 = MathRound(OrderStopLoss() / Point);
                  if (ObjectFind(l_name_12) < 0) ObjectCreate(l_name_12, OBJ_HLINE, 0, TimeCurrent(), OrderStopLoss());
                  ObjectSet(l_name_12, OBJPROP_COLOR, Orange);
                  ObjectSet(l_name_12, OBJPROP_WIDTH, 2);
                  li_24 = MathRound(ObjectGet(l_name_12, OBJPROP_PRICE1) / Point);
                  ObjectSet(l_name_12, OBJPROP_PRICE1, li_24 * Point);
                  if (li_24 != li_20) {
                     if (!OrderModify(OrderTicket(), OrderOpenPrice(), li_24 * Point, OrderTakeProfit(), OrderExpiration())) {
                        Print("ERROR OrderModify(SL): ", ErrorDescription(GetLastError()));
                        ObjectSet(l_name_12, OBJPROP_PRICE1, li_20 * Point);
                     }
                  }
                  ObjectSet(l_name_12, OBJPROP_BACK, TRUE);
               }
               if (OrderTakeProfit() > 0.0) {
                  l_name_12 = "_TP" + OrderTicket();
                  li_20 = MathRound(OrderTakeProfit() / Point);
                  if (ObjectFind(l_name_12) < 0) ObjectCreate(l_name_12, OBJ_HLINE, 0, TimeCurrent(), OrderTakeProfit());
                  ObjectSet(l_name_12, OBJPROP_COLOR, Orange);
                  ObjectSet(l_name_12, OBJPROP_WIDTH, 2);
                  li_24 = MathRound(ObjectGet(l_name_12, OBJPROP_PRICE1) / Point);
                  ObjectSet(l_name_12, OBJPROP_PRICE1, li_24 * Point);
                  if (li_24 != li_20) {
                     if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), li_24 * Point, OrderExpiration())) {
                        Print("ERROR OrderModify(TP): ", ErrorDescription(GetLastError()));
                        ObjectSet(l_name_12, OBJPROP_PRICE1, li_20 * Point);
                     }
                  }
                  ObjectSet(l_name_12, OBJPROP_BACK, TRUE);
               }
               if (OrderType() > OP_SELL) {
                  l_name_12 = "_OP" + OrderTicket();
                  li_20 = MathRound(OrderOpenPrice() / Point);
                  if (ObjectFind(l_name_12) < 0) ObjectCreate(l_name_12, OBJ_HLINE, 0, TimeCurrent(), OrderOpenPrice());
                  ObjectSet(l_name_12, OBJPROP_COLOR, Orange);
                  ObjectSet(l_name_12, OBJPROP_WIDTH, 2);
                  li_24 = MathRound(ObjectGet(l_name_12, OBJPROP_PRICE1) / Point);
                  ObjectSet(l_name_12, OBJPROP_PRICE1, li_24 * Point);
                  if (li_24 != li_20) {
                     if (!OrderModify(OrderTicket(), li_24 * Point, OrderStopLoss(), OrderTakeProfit(), OrderExpiration())) {
                        Print("ERROR OrderModify(OP): ", ErrorDescription(GetLastError()));
                        ObjectSet(l_name_12, OBJPROP_PRICE1, li_20 * Point);
                     }
                  }
                  ObjectSet(l_name_12, OBJPROP_BACK, TRUE);
               }
            }
         }
      }
   }
   for (l_pos_28 = ObjectsTotal() - 1; l_pos_28 >= 0; l_pos_28--) {
      l_name_12 = ObjectName(l_pos_28);
      if (StringSubstr(l_name_12, 0, 1) == "_") {
         if (OrderSelect(StrToInteger(StringSubstr(l_name_12, 3)), SELECT_BY_TICKET))
            if (OrderCloseTime() > 0) ObjectDelete(l_name_12);
      }
   }
}